0 => global int currentRainIdx;
0 => global int currentThunderIdx;
0 => global int currentSnowIdx;

// exact cloud position
0 => global float cloudPercent;
// increment per step
10::ms/500::ms => float posInc;

int rainPitch[16];
int thunderPitch[16];
int snowPitch[16];

// Edit
global int currentWeather;
global int currentEdit;
global int editPitch;
global Event editHappened;

fun void playRain() {
    SndBuf rainBufs[4];
    rainBufs[0] => dac;
    rainBufs[1] => dac;
    rainBufs[2] => dac;
    rainBufs[3] => dac;
    me.dir() + "RainPitch1.wav" => rainBufs[0].read;
    me.dir() + "RainPitch2.wav" => rainBufs[1].read;
    me.dir() + "RainPitch3.wav" => rainBufs[2].read;
    me.dir() + "RainPitch4.wav" => rainBufs[3].read;
    0 => rainBufs[0].gain;
    0 => rainBufs[1].gain;
    0 => rainBufs[2].gain;
    0 => rainBufs[3].gain;
    while (true) {
        if (currentRainIdx == 16) {
            0 => currentRainIdx;
        }
        
        if (rainPitch[currentRainIdx] != 0) {
            0 => rainBufs[rainPitch[currentRainIdx]-1].pos;
            0.5 => rainBufs[rainPitch[currentRainIdx]-1].gain;
            500::ms => now;
            0 => rainBufs[rainPitch[currentRainIdx]-1].gain;
        } else {
            500::ms => now;
        }
       
        currentRainIdx++;
    } 
}

fun void playThunder() {
    SndBuf thunderBufs[3];
    thunderBufs[0] => dac;
    thunderBufs[1] => dac;
    thunderBufs[2] => dac;
    me.dir() + "ThunderPitch1.wav" => thunderBufs[0].read;
    me.dir() + "ThunderPitch2.wav" => thunderBufs[1].read;
    me.dir() + "ThunderPitch3.wav" => thunderBufs[2].read;
    0 => thunderBufs[0].gain;
    0 => thunderBufs[1].gain;
    0 => thunderBufs[2].gain;
    while (true) {
        if (currentThunderIdx == 16) {
            0 => currentThunderIdx;
        }
        
        if (thunderPitch[currentThunderIdx] != 0) {
            0 => thunderBufs[thunderPitch[currentThunderIdx]-1].pos;
            0.5 => thunderBufs[thunderPitch[currentThunderIdx]-1].gain;
            500::ms => now;
            0 => thunderBufs[thunderPitch[currentThunderIdx]-1].gain;
        } else {
            500::ms => now;
        }
       
        currentThunderIdx++;
    }     
}

fun void playSnow() {
    SndBuf snowBufs[4];
    snowBufs[0] => dac;
    snowBufs[1] => dac;
    snowBufs[2] => dac;
    snowBufs[3] => dac;
    me.dir() + "SnowPitch1.wav" => snowBufs[0].read;
    me.dir() + "SnowPitch2.wav" => snowBufs[1].read;
    me.dir() + "SnowPitch3.wav" => snowBufs[2].read;
    me.dir() + "SnowPitch4.wav" => snowBufs[3].read;
    0 => snowBufs[0].gain;
    0 => snowBufs[1].gain;
    0 => snowBufs[2].gain;
    0 => snowBufs[3].gain;
    while (true) {
        if (currentSnowIdx == 16) {
            0 => currentSnowIdx;
        }
        
        if (snowPitch[currentSnowIdx] != 0) {
            0 => snowBufs[snowPitch[currentSnowIdx]-1].pos;
            0.5 => snowBufs[snowPitch[currentSnowIdx]-1].gain;
            500::ms => now;
            0 => snowBufs[snowPitch[currentSnowIdx]-1].gain;
        } else {
            500::ms => now;
        }
       
        currentSnowIdx++;
    }  
}

// this listens for events from Unity to update the sequence
fun void listenForEdit()
{
    while( true )
    {
        // wait for event
        editHappened => now;
        // update the pitch
        if (currentWeather == 0) {
            editPitch => rainPitch[currentEdit];
        } else if (currentWeather == 1) {
            editPitch => thunderPitch[currentEdit];
        } else {
            editPitch => snowPitch[currentEdit];
        }        
    }
}

fun void cloudPercentUpdate()
{
    currentRainIdx => int check;
    while( true )
    {
        // increment
        posInc +=> cloudPercent;
        if (check != currentRainIdx) {
            1 -=> cloudPercent;
            currentRainIdx => check;
        }
        // advance time
        10::ms => now;
    }
}

spork ~ playRain();
spork ~ playThunder();
spork ~ playSnow();
spork ~ listenForEdit();
spork ~ cloudPercentUpdate();

while (true) {
    1::ms => now;
}